\documentclass[english]{article}

\usepackage{babel}
\usepackage{graphicx}
\usepackage{alltt}
\usepackage{url}
\usepackage{tabularx}
%\usepackage{ngerman}
\usepackage{longtable}
\usepackage{color}
\usepackage{framed}
\usepackage{todonotes}
\usepackage{hyperref}
\usepackage{tikz}


\usepackage{xifthen}
\newboolean{showbackdoors}
\setboolean{showbackdoors}{true}  % set to false to hide subsection on backdoors for reviewing group


\newcommand{\specialcell}[2][c]{%
  \begin{tabular}[#1]{@{}c@{}}#2\end{tabular}}
  
\newcommand{\shrug}[1][]{%
\begin{tikzpicture}[baseline,x=0.8\ht\strutbox,y=0.8\ht\strutbox,line width=0.125ex,#1]
\def\arm{(-2.5,0.95) to (-2,0.95) (-1.9,1) to (-1.5,0) (-1.35,0) to (-0.8,0)};
\draw \arm;
\draw[xscale=-1] \arm;
\def\headpart{(0.6,0) arc[start angle=-40, end angle=40,x radius=0.6,y radius=0.8]};
\draw \headpart;
\draw[xscale=-1] \headpart;
\def\eye{(-0.075,0.15) .. controls (0.02,0) .. (0.075,-0.15)};
\draw[shift={(-0.3,0.8)}] \eye;
\draw[shift={(0,0.85)}] \eye;
% draw mouth
\draw (-0.1,0.2) to [out=15,in=-100] (0.4,0.95); 
\end{tikzpicture}}

\newenvironment{prettytablex}[1]{\vspace{0.3cm}\noindent\tabularx{\linewidth}{@{\hspace{\parindent}}#1@{}}}{\endtabularx\vspace{0.3cm}}
%\newenvironment{prettytable}{\prettytablex{l X}}{\endprettytablex}

\newcounter{threatCounter}
\newcommand\showCount[1][]{
    \refstepcounter{threatCounter}
    \ifthenelse{\equal{#1}{}}{}{\label{#1}}
    \thethreatCounter
}


\title{\huge\sffamily\bfseries System Description and Risk Analysis}
\author{Lina Gehri \and Dominique Portenier \and Luzian Bieri \and Ian Boschung}
\date{\today}


\begin{document}
\maketitle

%% **** please observe the page limit **** 
%% (it is not allowed to change the font size or page geometry to gain more space)
%% comment or remove lines below before hand-in
\begin{center}
%{\large\textcolor{red}{Page limit: 30 pages.}}
\end{center}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\tableofcontents
\pagebreak

\section{System Characterization}

\subsection{System Overview}
To allow secure communication between iMovies informants and employees, a certificate authority (CA) must be added to the iMovies software infrastructure. To host the application, we add two servers, one that will be called the main server to host the CA, the website, as well as the database, and the second one for data backups, called the backup server. The following figure \ref{fig:overview} shows the components on a top-level view.

\begin{figure}[htb]
    \centering
    \includegraphics[width=.8\textwidth]{Pictures/simpleWholesystem.drawio.png}
    \caption{This figure shows a slightly simplified overview of our system. }
    \label{fig:overview}
\end{figure}

\subsubsection{Main Server}
The main server hosts the CA, the frontend and backend of the website which provides access to the CA, and an SQL database of the user data (each in its own Docker container). A Traefik reverse proxy (also containerized) is responsible for forwarding the web traffic to the correct location.

Users can get a (new) certificate from the CA by logging into the website and authorizing themselves either with one of their current valid certificates or by their username and password. Once logged in, users can change their personal data, generate new certificates or revoke old ones in case they have lost their private key or the private key was corrupted.

Issued certificates are stored encrypted on the main server using asymmetric encryption. To protect the certificates, only the public key is stored on the main server.

A CA-admin can log in to an administration interface on the website using certificate-based authentication and get information about the number of currently issued certificates, the amount of revoked ones and the current serial number. 

A system admin may log into the server via SSH certificate-based authentication to perform maintenance work.

\subsubsection{Backup Server}
Issued certificates and encrypted private keys are regularly backed up to the backup server using \verb+rsync+.

A system admin may log into the server via SSH to perform maintenance work or to pull the backed-up certificates and encrypted private keys in an emergency. Even if the backup server was to be compromised, no private keys can be leaked without the decryption key.

\subsection{System Functionality}

%Describe the system's functions.

\subsubsection{Certificate Issuing}
After the successful login via the web interface using the user's password or a valid certificate (TLS client authentication), the user is given the possibility to adjust personal data. Afterward, the user can request a certificate including the private key which is provided as a downloadable file. The private key is then immediately encrypted and stored on the server, as is the certificate (in plain text).

\subsubsection{Certificate Revocation}
After the login - either via password or TLS client authentication - the user can revoke their certificate via the web interface. This certificate is then added to the revoke list of the CA (which can be requested at any time by a simple get request).

\subsubsection{Administrator Interface}
Using a dedicated web interface, additional information is provided to the CA admin who authenticated themselves via their certificate. This information includes the number of issued certificates, the number of revoked certificates, and the current certificate serial number.

\subsubsection{Key Backup}
For the company to decrypt older messages, a backup of all private keys (and certificates) is stored on the backup server.
They are encrypted using a pre-shared key given to a responsible person in the company. A system admin can access the backup server to download the encrypted files and then the decryption key is needed to decrypt them.

Scheduled by a \verb+cron+ job every night at two in the morning the content of the user database, the log files, and the archive of certificates and keys is backed up via \verb+rsync+ to an external backup server. Rsync uses SSH to copy the files and authentication happens via a dedicated backup RSA keypair.


\subsubsection{System Administration and Maintenance}
The System administrator can access both the backup and the main server via SSH. Authentication is only allowed via the public-key method and not via password. 

\subsection{Security Design}
%\todo{this whole section...}
%Describe the system's security design, including access control, key and session management,  and security of data at rest and in transit.

We use Docker on the main server to separate different services from each other. This has multiple benefits for the security of our main server and follows the principle of compartmentalization:

\begin{enumerate}
    \item We can control which service can communicate with which other service.
    \item Same for the directories: Every service has only access to the directories it needs for its service.
    \item Even if an attacker would gain root access via a vulnerability in either our website or the database service, all the other services, and the host Debian system would be hidden from the attacker by the Docker sandboxing system.
\end{enumerate}

\subsubsection{Access Control}

\paragraph{Main server access control} \mbox{}\\
The system has a minimal amount of open ports: port 22 open for SSH, port 443, and port 80 for HTTPS and HTTP.
Only a system administrator can log in to the sysadmin account on the main server over SSH using their admin certificate (password authentication is disabled). The sysadmin account has access to the whole system, including the Docker containers and they can execute commands with sudo (they need to enter a password). This is necessary in order for the sysadmins to set up and upgrade the server from time to time. 

To make it as hard as possible to get remote access to the main server and in case someone got access to the server, to access files or to escalate their privileges we follow a PCI-DSS Debian hardening list as closely as possible. This includes changes in the following categories:
\paragraph{SSH:} \label{serverAccessSSH}We added lines to the SSH configuration file to disallow password authentication, X11 forwarding, root login, and other things. Furthermore, we installed fail2ban which adds a firewall rule to \verb+iptables+ to block any IP that unsuccessfully tried to log in via SSH more than five times in five minutes for ten minutes to discourage any automated or brute-forcing attacks. By allowing SSH but restricting it we adhere to the principle of simplicity and usability as the system admins still have relatively simple access (they do not have to physically go to the server room to maintain the server) and also the principle of least privilege as only the system admins for whom it is absolutely necessary to have access, have access to the main server. As an extra measure, we log out anyone who has not typed anything in the terminal in five minutes.

\paragraph{Disabling Services:} \label{serverAccessServices}We disabled TIPC, DCCP, RDS, and SCTP following the principle of minimum exposure by disabling unused services that could in some cases lead to a security risk. Also, we disabled USB storage, thunderbolt, and firewire support to minimize the risks of a successful physical attack.

\paragraph{Firewall:} \label{serverAccessFirewall}To adhere to the principle of minimal exposure, we used \verb+iptables+ to create firewall rules to restrict access to the main server. The general INPUT policy is set to DROP and we only allow incoming connections to ports 80, 443, and 22 for HTTP, HTTPS, and SSH. Outgoing and established connections are allowed as well because it is necessary to reach the internet. E.g., when a system administrator updates the main server, an internet connection greatly increases the usability compared to if all internet access were prohibited.

\paragraph{Network Access:} \label{serverAccessNW} We followed the recommendations to secure network access by disabling source routing and ICMP acceptance as this is not a necessity for our system and therefore minimizes its exposure by disabling it.

\paragraph{File Permissions:} \label{serverAccessFP}We followed the recommendations to make some file permissions more restrictive. This contributes to the implementation of the least privilege and minimum exposure principles as for example we removed some read and write rights for "other".

\paragraph{Backup server access control} \mbox{} \\
To adhere to the minimum exposure principle we use a hardened system with only port 22 open for SSH. Only system administrators can log in to the backup server over SSH using their admin certificate (password authentication is disabled) and the main server can connect to the SSH port to back up the data.

To make it as hard as possible to get remote access to the backup server and in case someone got access, to access files or escalate their privileges we follow a PCI-DSS Debian hardening list as closely as possible. This includes changes in the following categories:
\paragraph{SSH:} Same as in main server access control \ref{serverAccessSSH}.
\paragraph{Disabling Services:} Same as in main server access control \ref{serverAccessServices}.
\paragraph{Firewall:} Same as in main server access control \ref{serverAccessFirewall}, except we do not allow connections to port 80 and 443 either.
\paragraph{Network Access:} Same as in main server access control \ref{serverAccessNW}.
\paragraph{File Permissions:} Same as in main server access control \ref{serverAccessFP}.

\paragraph{Server room access control} \mbox{} \\
Following the principles of minimum exposure and least privilege, we only allow system administrators to access the server rooms using any common physical access control system.


\subsubsection{Session Management}
Upon entering the correct password and username, the backend generates a random session token that is associated with a certain user in the database. Alternatively, if the user supplies a client certificate via TLS client authentication, the certificate is first validated and if successful, the user information is loaded from the database. On client certificate authentication, no token is generated, but instead, the certificate is sent along with every request using TLS client authentication which is built into all modern browsers, following the usability principle.


\subsubsection{Key Management}
%\todo{what exacty falls under key management?}
On the first setup of the system, the following keys and certificates are generated on an unconnected system:

\begin{itemize}
    \item CA root keys and root certificate
    \item ECDSA key pair used for admin authentication to the backup and main server
    \item RSA key pair used for encrypting the employees' private keys
    \item ECDSA key pair used by the main server to authenticate to the backup server.
\end{itemize}

All keys are generated on a fresh Debian system install not connected to the internet using the \verb+xor+ of two sources of randomness: /dev/random and randomness from an external source. Keys are transported password encrypted on a USB stick.

The SSH public keys are distributed to the servers where they will be used for authentication and are stored in the \texttt{ $\sim$/.ssh/authorized\_keys} directory of the respective user.

The CA-keys are stored in a specific folder on the main server. Write access is restricted to the root user. We then link the CA root key as a read-only file into the Docker container that provides the CA functionality.

The private keys corresponding to the users' certificates are stored encrypted using an asymmetric encryption scheme (RSA). The private key that can be used to decrypt these keys is handed to the iMovies company on a USB stick. This follows the principle of least privileges and compartmentalization. If the iMovies company mistrusts us, they may also generate the key pair themselves and only hand the public key used for encryption to the system admin.

\subsubsection{Data at Rest}
\paragraph{Employee database}
The employee database runs in a separate MySQL 5.7 Docker container. This container runs in the \textit{internal} Docker network which is only accessible to the backend container (explained in greater detail in figure \ref{fig:dockerServices}). Thus, the content of the database can only be edited through the REST API. This follows the compartmentalization security principle.

\paragraph{Certificates and private keys}
The private keys of the employees are immediately encrypted using RSA after they are generated and delivered to the employee. The private keys are then only stored in an encrypted format on the servers. This ensures that not even a system administrator can steal the private keys, but only the persons at iMovies responsible for this and holding the private key can decrypt them. This adheres to the least privilege principle, as a system administrator needs not to know the decryption key for the private keys. To protect the integrity of the certificates and keys, we don't propose any specific countermeasures. In the first place, it should be hard to gain access to our servers and tamper with the data. The public web API has a very limited and strict interface that doesn't allow modification of keys and certificates. The backup server is also another mechanism that protects the integrity of the keys, because if only one server gets compromised, we can use the other to restore the keys. 

\subsubsection{Data in Transit}
\paragraph{Client $\longleftrightarrow$ Main Server}
Connection only possible via \verb+HTTPS+ which is enforced by the Traefik Reverse-Proxy, therefore, all communication is encrypted.

\paragraph{System Administrator $\longleftrightarrow$ Main Server / Backup Server}
Connection only via certificate-based \verb+SSH+ which is encrypted.

\paragraph{Main Server $\longleftrightarrow$ Backup Server}
Backup with \verb+rsync+ via certificate-based SSH which is encrypted.

\paragraph{Between Docker containers}
All communication to the client happens through Traefik - the reverse proxy. All other communication, i.e. Database-API happens within Docker's own networks which aren't directly accessible from the outside.
    
\subsubsection{Defenses against common web vulnerabilities}

We use different mechanisms and protection systems against these attacks:

\begin{prettytablex}{lp{9.1cm}p{}}
\hline
SQL-Injection & We use the python library Sqlalchemy. Sqlalchemy automatically sanitizes inputs except when using the raw SQL or text feature, which we never do.\\
\hline
XSS attack & Using the React framework to render dynamic content all texts are automatically sanitized by React.\\
\hline
CSRF attack & All state-changing requests must include an ETag value, which is a number calculated based on the current state of the asset. While this is not a fool-prove unique token for every request, it at least ensures that the attacker must create a more elaborate attack by first getting the actual ETag value from the server and then using it for the attack.\\
\hline
SSTI & In our solution, no server-side rendering happens. The user receives a finished HTML and JavaScript application which then fetches any dynamic content from the API and renders it client-side.

\end{prettytablex}


\subsection{Monitoring and Logging}

Docker also offers some advantages with respect to logging: The logs of every container are stored under \textit{/var/lib/docker/containers/}. They can be examined by using the \texttt{docker logs} command. In the API, we use standard logging provided by the flask framework to output messages on different levels, including a debug level, warn level, and error level. Those logs are then saved by Docker in the API container's log file. Similarly, for the database, we log all transactions using Docker log. The logs are also backed up to the backup server. With this, we follow the principles of complete mediation and traceability.

\subsection{Components}
In this section, we first explain what platforms we used and then describe the additional applications and packets we installed on each server. Lastly, we describe the data records.

% \begin{figure}[htb]
%     \centering
%     \includegraphics[width=.8\textwidth]{Pictures/Setup.jpeg}
%     \caption{Caption}
%     \label{fig:my_label}
% \end{figure}

%List all system components and their interfaces, subdivided, for example, into categories such as platforms, applications, data records, etc. For each component, state its relevant properties.
%Describe exactly how these components are distributed on various computers and exactly what additional components are required to enforce the security measures. 
 
\subsubsection{Platforms}
Our system proposes the introduction of two hardware servers to the iMovies infrastructure. The client host is an example of what an iMovies employee can use to connect to use the certificate service. As operating systems the following platforms are used:
\begin{enumerate}
    \item Client host: Off the shelf Ubuntu 20.04 LTS installation with Firefox.
    \item Main Server: Debian buster (Linux kernel 4.19.0-17-amd64) system with Docker installed.
    \item Backup Server: Debian buster (Linux kernel 4.19.0-17-amd64) system
\end{enumerate}
Both the main server and the backup server are hardened as mentioned in \ref{serverAccessServices}. Since we are using Docker, we could easily add more similarly configured machines to a swarm, to cope with higher loads. Or even distribute the different functionalities across different servers.

\subsubsection{Main Server: Applications and Components}

On the main server we use the following applications:
\begin{enumerate}
    \item \textbf{Docker} We use Docker to separate different functionalities listed below. 
    \item \textbf{rsync} Rsync is the copying tool we use for our automated backup.
    \item \textbf{fail2ban} We use fail2ban to block IP addresses that try to log in via SSH too many times.
    \item \textbf{auditd} We use auditd to collect logs.
    \item \textbf{iptables-persistent} We use this packet to make sure our firewall rules are persistent even if there is a reboot.
    \item \textbf{iptables} We use iptables as a firewall. The configuration is explained in more detail in \ref{serverAccessFirewall}.
\end{enumerate}

As mentioned above we use Docker to separate different functionalities and components. The following Docker containers all run in parallel inside the main server:
\begin{enumerate}
    \item \textbf{Traefik reverse proxy} It redirects any requests via http to https and any requests via https to the respective container. We added this proxy to enforce HTTPS. The Traefik reverse proxy is configured to enforce that the HTTPS protocol is used and makes it impossible to use HTTP. It also forwards the incoming traffic to either the Nginx container or the REST API container as needed. Furthermore, it is responsible to forward client certificates to the backend container.
    \item \textbf{Nginx Docker container} The Nginx container serves the frontend which was built using React and create-react-app. 
    \item \textbf{MySql Database container} It can only be reached from the REST API Docker container since they are running in a dedicated Docker network. It runs the latest image from \textit{mysql5.7} and stores its database's content persistently on the Main Server.
    \item \textbf{REST API container} This container runs the Flask API which is the backend for the website. Serving the API is done via \textit{bjoern}, a special WSGI Server, and through a special middleware that enables more detailed logging.
\end{enumerate}

To further encapsulate the different services, we installed two Docker networks of which only one is accessible from the outside. The REST API container is the only one that has access to both networks, effectively routing the request from the outside through the API to the database. This is visible in Figure \ref{fig:dockerServices}. The Docker network that is accessible from outside is called external network. It includes the Traefik reverse proxy, the React frontend, and the flask backend. The internal network is not accessible from the outside and only the flask backend and the MySQL server are part of it.

\begin{figure}[htb]
    \centering
    \includegraphics[width=.8\textwidth]{Pictures/separatet_arrows.png}
    \caption{Services Running in Docker and Docker networks on the main server. The Docker network that is accessible from outside is called external network. It includes the Traefik reverse proxy, the React frontend, and the flask backend. The internal network is not accessible from the outside and only the flask backend and the MySQL server are part of it. }
    \label{fig:dockerServices}
\end{figure}

 

\subsubsection{Backup Server: Applications and Components}
On the backup server, we installed the following applications, they differ from the applications on the main server only by the fact that there is no Docker and no rsync on the backup server:
\begin{enumerate}
    \item \textbf{fail2ban} We use fail2ban to block IP addresses that try to log in via SSH too many times.
    \item \textbf{auditd} We use auditd to collect logs.
    \item \textbf{iptables-persistent} We use this packet to make sure our firewall rules are persistent even if there is a reboot.
    \item \textbf{iptables} We use iptables as a firewall. The configuration is explained in more detail in \ref{serverAccessFirewall}.
    
\end{enumerate}
We use the backup server only to store the backed up data. The main server regularly connects to the backup server to back up the data using rsync.



\subsubsection{Data Records}
\paragraph{User database} The user database resides in a MySQL Docker container on the main server. Only the backend Docker container can query it because we used separate Docker networks.

\paragraph{Private keys and certificates} The private keys and certificates are stored both on the main server and the backup server. When the private keys are created in the backend Docker container on the main server, they are encrypted before they are stored in a directory that is mapped into the container. The certificates are stored in plain text in a sibling folder. Since certificates are signed with our root CA key and the certificate binds the public key to the root CA, their integrity is protected. The encrypted keys and the certificates are copied regularly to the backup server where they are again stored in sibling folders.


\ifthenelse{\boolean{showbackdoors}}{
% show for handed-in version

\subsection{Backdoors}

\subsubsection{Doable Backdoor}
The API comes with a SwaggerUI, a violation of the principle of minimal exposure by itself. When analyzing the authentication methods it becomes obvious that there is a second method not used by the frontend (see figure \ref{fig:avail_auth}). To authenticate the user, normally the session token is sent as \textit{Authorization} in the request header. But sending something in the field \textit{X-UID-Authorization} seems to be accepted as well. Plugging in any valid UID gives almost the same scope as the session token and enables the attacker to change the user's password.

\begin{figure}
    \centering
    \includegraphics[width=.8\textwidth]{Pictures/Available_auth.png}
    \caption{Available authorization methods according to SwaggerUI}
    \label{fig:avail_auth}
\end{figure}

\subsubsection{Hard Backdoor}

We created an SSH RSA key from two adjacent primes. This is bad because if the two primes are very close together, n can be factorized very fast (for example using \url{https://www.alpertron.com.ar/ECM.HTM}). This SSH key can be used to log into the main server VM with the sysadmin user. The public part of the SSH key can be found in the source code of the website when doing "inspect element".

%% do not delete the three lines below
}{ 
% empty for reviewing group's version
} 


\section{Risk Analysis and Security Measures}

\subsection{Assets}
In this section, we list the relevant assets and their required security properties.

  
\subsubsection{Physical}
\paragraph{Servers}
The physical backup server, as well as the main server, must be in an area with access control such that only authorized persons can physically access it, namely only the system administrators.

\paragraph{Internet Connectivity}
Internet connectivity is required to grant and revoke certificates as well as for administrative access. The internet connectivity can be up, restricted, or down. Only authorized persons (system administrators) must have physical access to the router and the physical cables. Therefore, the router connecting the servers to the internet should be in the same place as the servers. 

\paragraph{Internal Connectivity Backup Server to Main Server}
The connectivity between the backup server and the main server is crucial to ensure the correct backup of the keys. They are directly connected with fiber cables. The connectivity can be up, restricted, or down. Only authorized persons must have physical access to the cables.

\paragraph{Reporters' Hardware}
Desktops and laptops are used by the reporters to access their emails. They must be password protected with a suitable password policy and have anti-virus software installed.


\subsubsection{Logical} 
\paragraph{Software}
All software must be regularly updated to make sure all security patches are installed. 
\begin{itemize}
    \item[] Backup server: Debian buster (Linux kernel 4.19.0-17-amd64)
    \item[] Main server: Debian buster (Linux kernel 4.19.0-17-amd64), Docker
    \item[] MySQL Docker container: MySQL
    \item[] Frontend Docker container: Nginx serving a React App
    \item[] Backend and CA Docker container: Apache - WSGI Server, running a Flask application
\end{itemize}

\paragraph{Employee Database}
The employee database contains the usernames and passwords of the employees and some other data associated with each of them. This database is therefore one of the more valuable parts of the system and must have the highest security standard. The system must enforce that every user can only read and change his own data.

\paragraph{Key storage}
The key storage contains the certificates and the encrypted private keys of all employees. All company employees should have access to the certificates, but no one should have access to the encrypted private keys except some highly trusted individuals of iMovies. Possession of the private keys allows forgery and decryption of all iMovies employees' data. The integrity of all issued certificates and the trustworthiness thereof essentially boils down to the security of our root certificate and its keys on the main server and the security of the stored private keys on the main server as well as the backup server. To protect and validate every user's information it is crucial to protect the stored and backed-up private keys.

\subsubsection{Persons}
\paragraph{System Administrator}
System administrators maintain the servers and the internet connectivity. They have access to the employee database and therefore have to be loyal and trustworthy.
\paragraph{Encryption Key Holders of iMovies}
The encryption key holder(s) can decrypt all private keys of the reporters. This means that they have access to the email content and could also forge signatures.


\subsubsection{Intangible Goods}
\paragraph{Informant Confidence}
People will only become informants if they can be sure that their personal information will stay confidential. If an informant's personal information is leaked that can be dangerous and other people will be less likely to come forward as new informants which would be detrimental to the company.

\paragraph{Credibility of Reports}
The credibility of their reports is important to the company's continued existence. If they do not have enough sources their reports may lose credibility and people may lose interest in them.


\subsection{Threat Sources}

In this section, we name and describe potential threat sources including their motivation.


\paragraph{Employees} The engineers who implement the system may have the interest to gain more money by selling information to other threat sources. The system admins who have access to the private keys may want to betray the company for money or idealistic motifs. Cleaning staff and the concierge may have access to the physical hardware.
\paragraph{Script Kiddies} Since the systems considered are connected to the internet, they are exposed to attacks by script kiddies. The motivation of script kiddies is normally not monetary, but instead, they see systems as a challenge and want to have fun and prove that they are good. Script kiddies are not very persistent or especially skilled.
\paragraph{Governments} Governments may have an interest to know what information iMovies possesses in order to prevent information from being published. May hire skilled hackers.
\paragraph{Skilled hacker} May want to break the system as a challenge or for monetary interest, e.g. being hired by a government or selling information after retrieving it.
\paragraph{Malware} Directed malware may be used by other thread sources and there is always the threat of undirected malware.
\paragraph{Nature} The physical location of our servers may be damaged floods, earthquakes, or other natural causes. Such events happen with a certain probability every year and cannot be foreseen a long time before they happen. Nature itself doesn't have any motivation. 

\subsection{Risks Definitions}

We define likelihood, impact and risk level in the tables \ref{tab:likelihood}, \ref{tab:impact}, and \ref{tab:risklevel}.

%\subsubsection{Tools}

\begin{center}
\begin{table}[h]
\begin{tabular}{|l|l|}

\hline
\multicolumn{2}{|c|}{\bf Likelihood} \\
\hline
Likelihood & Description \\
\hline
\hline
High   & \specialcell{  The threat source has high stakes in an investigation of iMovies \\
                        and is therefore highly motivated to exploit a given vulnerability \\
                        and infiltrate the system. Their large capabilities to exploit \\
                        vulnerabilities cannot be countered by the controls that are in place.} \\
\hline
Medium & \specialcell{  The threat source is motivated to exploit a given vulnerability. They \\
                        have the capabilities to explore given vulnerabilities, however, \\
                        they might be hindered by the controls that are in place.} \\
\hline
Low   & \specialcell{  The threat source either has no motivation to exploit a given \\
                        vulnerability, or they are simply incapable to exploit it because \\
                        of missing capabilities or because controls are in place to \\
                        prevent the vulnerability from being exploited.} \\
\hline
\end{tabular}
\caption{The likelihood table defining the likelihoods high, medium, and low.}
\label{tab:likelihood}
\end{table}

\begin{table}[h]
\begin{tabular}{|l|l|}
\hline
\multicolumn{2}{|c|}{\bf Impact} \\
\hline
Impact & Description \\
\hline
\hline
High   & \specialcell{  The event may result in an unauthorized disclosure of all informant \\
                        and employee information and with it in human death or serious \\
                        injury as well as damage to the company's reputation. The event may \\
                        also lead to a complete loss of all stored private keys.} \\
\hline
Medium & \specialcell{  The event may result in an unauthorized disclosure of some \\ 
                        informant and employee information and with it in human injury as \\
                        well as damage to the company's reputation.} \\
\hline
Low   & \specialcell{  The event may result in a small damage to the company's reputation \\ or in a temporary outage of the system.} \\
\hline
\end{tabular}
\caption{The impact table defining the impacts high, medium, and low}
\label{tab:impact}
\end{table}
\end{center}

\begin{center}
\begin{table}[h]
\begin{tabular}{|l|c|c|c|}
\hline
\multicolumn{4}{|c|}{{\bf Risk Level}} \\
\hline
{{\bf Likelihood}} & \multicolumn{3}{c|}{{\bf Impact}} \\ %\cline{2-4}
     & Low & Medium & High \\  \hline
 High & Low & Medium & High  \\
\hline
 Medium & Low & Medium & Medium \\
\hline
 Low & Low & Low & Medium \\
\hline
\end{tabular}
\caption{The risk level table defining how the combination of likelihood and impact leads to high, medium, and low risk levels}
\label{tab:risklevel}
\end{table}
\end{center}

\subsection{Risk Evaluation}
%List all potential threats and the corresponding countermeasures. Number them consecutively.
%Estimate the risk based on the information about the threat, the threat sources, and the corresponding countermeasure. Adhere to the risk definitions you have given above. As a sanity check, there should be at least one high-risk entry.

%Evaluate the likelihood, impact, and the resulting risk,  \emph{after implementation of the corresponding countermeasures}. Formulate the threats in active, not passive, 
%voice: who (threat source) does what (threat action)? \\
%\it L stands for Low, \it M for medium, and \it H for High.


\subsubsection{ Physical: Server}

\begin{footnotesize}
\begin{prettytablex}{lp{3.1cm}p{4.9cm}lll}
No. & Threat &  Countermeasure(s) & L & I & Risk \\
\hline
\showCount & An employee working at the server site accidentally tampers with the server, e.g. unplugs it.  
    & Only system administrators can access the server room (no cleaning service etc.). Redundant setup / redundant parts e.g. two power supplies.& {\it L} & {\it L} & {\it L} \\
\hline
\showCount & Because of natural causes the server room is destroyed, e.g. by a flood or a fire & 
    Service contract with the manufacturer, spare machines on hand, fast setup of new machines, e.g. docker-compose. The backup server resides in a different physical location. Containerized applications that can easily be deployed on a different machine or are even running on several machines at once (swarm setup).& {\it L} & {\it M} & {\it L} \\
\hline
\showCount & Nature: With time, components may break because of over-use, corrosion, etc. The threat source in this case is nature. & 
    Service contract with the manufacturer, spare machines on hand, fast
                setup of new machines. Containerized applications that can easily be deployed on a different machine or are even running on several machines at once (swarm setup).& {\it L} & {\it H} & {\it L} \\
\hline
\showCount & An attacker accesses the physical system and tampers with it, e.g. removing the hard drive or booting a different operating system  & 
    Secure the server room with a digital system and log all accesses to the server room. Disable physical interfaces as much as possible. Potentially use full disc encryption & {\it L} & {\it H} & {\it M} \\
\hline
\end{prettytablex}
\end{footnotesize}




\subsubsection{ Physical: Connectivity (Internet and Internal) }
\begin{footnotesize}
\begin{prettytablex}{lp{3.1cm}p{4.9cm}lll}
No. & Threat & Countermeasure(s) & L & I & Risk \\
\hline
\showCount & Nature: Cable or router may break, connectivity down (internally or externally). & Service contract with the manufacturer. Appropriate SLAs with the internet providers. Distribution over different geographic locations and providers & {\it L} & {\it H} & {\it L} \\
\hline
\showCount & A government or a skilled hacker launches a DDOS attack against our main server & Use DDOS protection, e.g. cloudflare & {\it L} & {\it M} & {\it L} \\
\hline
\showCount & A script kiddie sends many requests at once, overloading the API, or blocking the connection to the internet or the connection between the API and the Database (unintentional DOS) & Block IP's which send too many requests. Create a Rate limit (requests per second) e.g. in the reverse proxy to protect the database. & {\it L} & {\it L} & {\it L} \\
\hline
\end{prettytablex}
\end{footnotesize}


\subsubsection{ Physical: Reporters' Hardware }
\begin{footnotesize}
\begin{prettytablex}{lp{3.1cm}p{4.9cm}lll}
No. & Threat & Countermeasure(s) & L & I & Risk \\
\hline
\showCount[reporterMalware] & Malware: Laptop or desktop is infected with malware such as a key-logger. & Up to date anti-virus installed on all machines, restrict admin rights of the employer's user where possible, raise cyber security awareness of employees (e.g. not to click links in emails). & {\it H} & {\it H} & {\it H} \\
\hline
\showCount & By some unfortunate Circumstances (Weather, earthquake, accident, ...) the reporter's machine gets destroyed. & Rigorous backups of all Certificates. So no information gets lost. & {\it M} & {\it L} & {\it L} \\
\hline
\end{prettytablex}
\end{footnotesize}


\subsubsection{{ Logical: Software }}
\begin{footnotesize}
\begin{prettytablex}{lp{3.1cm}p{4.9cm}lll}
No. & Threat & Countermeasure(s) & L & I & Risk \\
\hline
\showCount[dependencies] & The skilled Hacker or the government exploit vulnerable / malicious dependency & Update schedule, rebuild Docker images regularly. Only use well-established and open-source packages. & {\it M} & {\it M} & {\it M} \\
\hline
\showCount[bugs] & The skilled Hacker or the government exploit bugs in our code & Use as little self-written code as possible, use libraries wherever possible. & {\it H} & {\it M} & {\it M} \\
\hline
\end{prettytablex}
\end{footnotesize}


\subsubsection{{ Logical: Employee Database }}
\begin{footnotesize}
\begin{prettytablex}{lp{3.1cm}p{4.9cm}lll}
No. & Threat & Countermeasure(s) & L & I & Risk \\
\hline
\showCount & Professional Hacker / Government directly attack the main Server, try to access the Database & Database is not directly accessible through the internet (running in a separate Docker network). The user flask uses to access the database only has minimal permissions it needs. & {\it L} & {\it H} & {\it L} \\
\hline
\showCount & Professional Hacker / Government/ Script Kiddie may perform an SQL Injection & Proper handling of user input, i.e. escaping. Use SQLAlchemy instead of plain SQL statements. This package performs input sanitation and comes with prepared SQL statements. & {\it L} & {\it M} & {\it L} \\
\hline
\end{prettytablex}
\end{footnotesize}

\subsubsection{{ Logical: Key Storage }}
\begin{footnotesize}
\begin{prettytablex}{lp{3.1cm}p{4.9cm}lll}
No. & Threat & Countermeasure(s) & L & I & Risk \\
\hline
\showCount & Content of key storage may be leaked & Keys are stored encrypted using a asymmetric encryption & {\it L} & {\it H} & {\it M} \\
\hline
\showCount[backupDeletion] & Backup may be deleted by an employee or a hacker who gains access to the server & Use a hardened os with minimal connectivity (only via SSH) and enforce private/public-key authentication & {\it L} & {\it M} & {\it L} \\
\hline
\showCount & Private key used to encrypt the key storage might fall into a hacker's or government's hands & Private key is \textbf{never} stored on the Server and optimally stored on a USB-Stick in a physically safe manner. & {\it L} & {\it H} & {\it M} \\
\hline
\showCount & Private key used to encrypt the key storage or to issue certificates might brute forced by a determined government in order to issue own certificates & Select keysize large enough & {\it L} & {\it H} & {\it M} \\
\hline
\showCount & Ransomware encrypts keys data & Backups. Very restrictive updates, no new programs allowed. All running applications run in separate containers, breaking out is impossible. & {\it L} & {\it M} & {\it L} \\
\hline
\end{prettytablex}
\end{footnotesize}

\subsubsection{{ Logical: Backup }}
\begin{footnotesize}
\begin{prettytablex}{lp{3.1cm}p{4.9cm}lll}
No. & Threat & Countermeasure(s) & L & I & Risk \\
\hline
\showCount & A government gains physical access to the backup server's hard drive & Backups are stored encrypted using an asymmetric encryption with a large key size& {\it L} & {\it H} & {\it M} \\
\hline
\showCount & A skilled hacker gains access to the backup server & The backup server has very restrictive access control and backups are stored encrypted using an asymmetric encryption & {\it L} & {\it H} & {\it M} \\
\hline
\showCount & Ransomware encrypts backup data & Several backups on different machines. Very restrictive updates, no new programs allowed. & {\it L} & {\it M} & {\it L} \\
\hline
\end{prettytablex}
\end{footnotesize}

\subsubsection{{ Logical: Information }}
This contains: Email content, Informants and Reporters of iMovies, and their personal info.\\
\begin{footnotesize}
\begin{prettytablex}{lp{3.1cm}p{4.9cm}lll}
No. & Threat & Countermeasure(s) & L & I & Risk \\
\hline
\showCount & Skilled hacker or government intercepts Email traffic & Communication only via encrypted (and signed) emails & {\it L} & {\it L} & {\it L} \\
\hline
\showCount & A skilled hacker or a member of a adversary go
vernment tries to send email with altered or wrong content & Signed and encrypted communication & {\it L} & {\it L} & {\it L} \\
\hline
\showCount[reporterKidnap] & Reporters get forced to hand out information & Certificates have only a short validity & {\it M} & {\it H} & {\it M} \\
\hline
\end{prettytablex}
\end{footnotesize}


\subsubsection{ Persons: System Administrators }
\begin{footnotesize}
\begin{prettytablex}{lp{3.1cm}p{4.9cm}lll}
No. & Threat & Countermeasure(s) & L & I & Risk \\
\hline
\showCount & Sysadmin gets bribed or forced to hand out information/private keys form the storage & Private keys are stored encrypted, the sysadmins don't have the key to decrypt them & {\it L} & {\it M} & {\it L} \\
\hline
\showCount & Sysadmin looses his SSH access key & More than one sysadmin have the possibility to log into the servers via their key & {\it L} & {\it M} & {\it L} \\
\hline
\end{prettytablex}
\end{footnotesize}


\subsubsection{ Persons: Encryption Key Holders of iMovies }
\begin{footnotesize}
\begin{prettytablex}{lp{3.1cm}p{4.9cm}lll}
No. & Threat & Countermeasure(s) & L & I & Risk \\
\hline
\showCount &  Serious illness, accident or other event that would interrupt or end their employment unexpectedly. & Multiple trusted persons at iMovies should have access to the decryption key & {\it L} & {\it M} & {\it L} \\
\hline
\showCount[keyholderKidnap] & Government: Bribery or corruption to give away the decryption key. & The responsible person from iMovies holding the decryption key should be trusted by iMovies. iMovies can choose to use a secret sharing scheme (\url{https://en.wikipedia.org/wiki/Secret_sharing}) to improve the security of the decryption key. & {\it M} & {\it H} & {\it M} \\
\hline
\end{prettytablex}
\end{footnotesize}

\subsubsection{ Intangible: Informant Confidence }
\begin{footnotesize}
\begin{prettytablex}{lp{3.1cm}p{4.9cm}lll}
No. & Threat & Countermeasure(s) & L & I & Risk \\
\hline
\showCount & A government tries to undermine security by convincing informants that our system is not secure, probably with data stolen in a different attack as proof. & Be transparent about prior security attacks and the measures taken to protect against them. & {\it M} & {\it M} & {\it M} \\
\hline
\end{prettytablex}
\end{footnotesize}



\subsubsection{Risk Acceptance}

%List all medium and high risks, according to the evaluation above. For each risk, propose additional countermeasures that could be implemented to further reduce the risks.

\begin{footnotesize}
\begin{prettytablex}{p{2cm}X}
No. of threat & Proposed additional countermeasure including expected impact  \\
\hline
\ref{reporterMalware} & The company should be aware that in some cases, a reporter's laptop will be infected and this person's key could be leaked. This means that a single person's private data may be compromised, but all other reporters' keys should still be save. It is important that attacks can be discovered. This could be done by having regular security inspections of reporters' equipment. \\
\hline
\ref{dependencies} & If iMovies wants to minimize the risk for this threat, they could pay us to do an in-depth security review of all used dependencies. \\
\hline
\ref{bugs} & We could organize a bounty hunt to minimize the possibility of security errors in our code. \\
\hline
\ref{backupDeletion} & The most secure option would be to have a backup on a USB key / hard drive that is refreshed in a regular interval, but otherwise not connected to any part of the system. \\
\hline
\ref{reporterKidnap} & We could implement a special emergency password. If this password is given instead of the normal password, all this user's certificates are immediately revoked and the company is notified. \\
\hline
\ref{keyholderKidnap} & The two out of three people scheme could be extended to a key sharing mechanism involving more people. iMovie can freely define how many persons should be needed to decrypt the keys and how many keys can be left out. \\
\hline

\end{prettytablex}
\end{footnotesize}

\end{document}

%%% Local Variables: 
%%% mode: latex
%%% TeX-master: "../../book"
%%% End: 
